import _extends from "@babel/runtime/helpers/esm/extends";

/**
 * Base class for the component
 */
export var CLASS = 'sui-AtomButton';
/**
 * {Deprecated} Types of buttons
 */

export var TYPES = ['primary', 'accent', 'secondary', 'tertiary'];
/**
 * Different designs for the button
 */

export var DESIGNS = {
  SOLID: 'solid',
  OUTLINE: 'outline',
  FLAT: 'flat',
  LINK: 'link'
};
export var ALIGNMENT = {
  CENTER: 'center',
  LEFT: 'left',
  RIGHT: 'right'
};
/**
 * Available colors for the button
 */

export var COLORS = ['primary', 'accent', 'neutral', 'success', 'alert', 'error', 'social-facebook', 'social-twitter', 'social-google', 'social-youtube', 'social-whatsapp', 'social-instagram'];
/**
 * Positions to be used when the button is used on group
 */

export var GROUP_POSITIONS = {
  FIRST: 'first',
  MIDDLE: 'middle',
  LAST: 'last'
};
/**
 * Shapes for the button
 */

export var SHAPES = {
  SQUARED: 'squared',
  ROUNDED: 'rounded',
  CIRCULAR: 'circular'
};
/**
 * Sizes for the button
 */

export var SIZES = {
  SMALL: 'small',
  LARGE: 'large'
};
/**
 * All the available modifiers for the button
 */

export var MODIFIERS = ['disabled', 'fullWidth', 'focused', 'negative', 'link'];
/**
 * Icon available positions
 */

export var ICON_POSITIONS = {
  LEFT: 'left',
  RIGHT: 'right',
  CENTER: 'center'
};
/**
 * Props for the button in order to filter the rest of attributes
 */

export var OWN_PROPS = [].concat(TYPES, SIZES, ['alignment', 'children', 'className', 'color', 'design', 'focused', 'fullWidth', 'groupPosition', 'isLoading', 'leftIcon', 'loadingText', 'negative', 'rightIcon', 'type']);
/**
 * Display Name for Atom Icon component
 */

export var ATOM_ICON_DISPLAY_NAME = 'AtomIcon';
/**
 * Map of sizes of the button with the AtomIcon usage
 * The key is the size of the button
 * The value is the size of the icon
 */

export var ATOM_ICON_SIZES_MAPPER = {
  "default": 'small',
  small: 'small',
  large: 'medium'
};
export var TYPES_CONVERSION = {
  primary: {
    design: DESIGNS.SOLID,
    color: 'primary'
  },
  accent: {
    design: DESIGNS.SOLID,
    color: 'accent'
  },
  secondary: {
    design: DESIGNS.OUTLINE,
    color: 'primary'
  },
  tertiary: {
    design: DESIGNS.FLAT,
    color: 'primary'
  }
};
export var createClasses = function createClasses(array, sufix) {
  if (sufix === void 0) {
    sufix = '';
  }

  return array.reduce(function (res, key) {
    var _extends2;

    return _extends({}, res, (_extends2 = {}, _extends2[key] = CLASS + "--" + key + sufix, _extends2));
  }, {});
};